void dbg_disp(int i);

extern char *pBits;
int gc_and, gc_or;

void grcg_setcolor( int mode, int color )
{
    gc_and = (0xff ^ mode) & 0x0f;
    gc_or = mode & color;
}

void hline(int, int, int, int c);
void vline(int, int, int, int c);

void gc_hline(int x1, int x2, int y)
{
    int i;
    char a;

    if (x1 > x2) {i = x2; x2 = x1; x1 = i;}
    if (x1 > 639 || y > 399) return;
    if (x2 > 639) x2 = 639;
    for (i = x1; i <= x2; i++) {
        a = pBits[640*(399-y)+i] & gc_and;
        pBits[640*(399-y)+i] = a | gc_or;
    }
}

void gc_vline(int x, int y1, int y2)
{
    int i;
    char a;

    if (y1 > y2) {i = y2; y2 = y1; y1 = i;}
    if (x > 639 || y1 > 399) return;
    if (y2 > 399) y2 = 399;
    for (i = y1; i <= y2; i++) {
        a = pBits[640*(399-i)+x] & gc_and;
        pBits[640*(399-i)+x] = a | gc_or;
    }
}

void grcg_hline( int x1, int x2, int y )
{
    gc_hline(x1, x2, y);
}

void grcg_vline( int x, int y1, int y2 )
{
    gc_vline(x, y1, y2);
}

void grcg_boxfill( int x1, int y1, int x2, int y2 )
{
    int i;

    for (i = y1; i <= y2; i++) {
        gc_hline(x1, x2, i);
    }
}

void grcg_off(void)
{
}

void xor_vline(int x) /* R G B 3v[XOR */
{
    int i;

    for (i = 49; i <= 381; i++) {
        pBits[640*(399-i)+x] ^= 0x07;
    }
}

void put_note(int x, int y, int num)
{
    extern unsigned char nimage[];
    unsigned char *p;
    int i, j;

    p = nimage;
    p += 5 * num;

    for (j = y; j < y + 5; j++) {      /* c5hbg */
	for (i = x; i < x + 8; i++) {
	    if (p[j-y] & 1 << (7-i+x))
	      pBits[640*(399-j)+i] |= 1;
	}
    }
}
